## ros-iron-fuse-loss 1.0.1

=== test/CMakeLists.txt ===
# CORE GTESTS ======================================================================================
ament_add_gtest(test_loss_function test_loss_function.cpp)
target_link_libraries(test_loss_function ${PROJECT_NAME})

ament_add_gtest(test_composed_loss test_composed_loss.cpp)
target_link_libraries(test_composed_loss ${PROJECT_NAME})

ament_add_gtest(test_huber_loss test_huber_loss.cpp)
target_link_libraries(test_huber_loss ${PROJECT_NAME})

ament_add_gtest(test_tukey_loss test_tukey_loss.cpp)
target_link_libraries(test_tukey_loss ${PROJECT_NAME})

ament_add_gtest(test_scaled_loss test_scaled_loss.cpp)
target_link_libraries(test_scaled_loss ${PROJECT_NAME})

# Qwt Loss Plot Tests
option(BUILD_WITH_PLOT_TESTS "Build with plot tests. These test might fail to run in headless systems." OFF)
if(BUILD_WITH_PLOT_TESTS)
  find_package(Qt5 REQUIRED COMPONENTS Core Widgets)

  # Find Qwt using FindQwt.cmake copied from:
  # https://gitlab.kitware.com/cmake/community/-/wikis/contrib/modules/FindQwt
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake")
  find_package(QWT REQUIRED)

  ament_add_gtest(test_qwt_loss_plot test_qwt_loss_plot.cpp)
  target_link_libraries(test_qwt_loss_plot ${PROJECT_NAME})
  target_include_directories(test_qwt_loss_plot
    PRIVATE
      ${Qt5Core_INCLUDE_DIRS}
      ${Qt5Widgets_INCLUDE_DIRS}
      ${QWT_INCLUDE_DIRS}
  )
  target_link_libraries(test_qwt_loss_plot
    ${Qt5Core_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QWT_LIBRARIES}
  )

  option(BUILD_WITH_INTERACTIVE_TESTS "Build with interactive tests" OFF)
  if(BUILD_WITH_INTERACTIVE_TESTS)
    target_compile_definitions(test_qwt_loss_plot PUBLIC INTERACTIVE_TESTS)
  endif()
endif()

=== debian/changelog ===
ros-iron-fuse-loss (1.0.1-3jammy) jammy; urgency=high



 -- Stephen Williams <swilliams@locusrobotics.com>  Thu, 02 Mar 2023 16:00:00 -0000

ros-iron-fuse-loss (1.0.0-3jammy) jammy; urgency=high

  * fuse -> ROS 2 : Doc Generation (#278 <https://github.com/locusrobotics/fuse/issues/278>)
    * Port doc generation and fix package.xml for linting
    * Fix small bugs in package.xml
    * Use default rosdoc2 settings
    * Use default rosdoc2 settings
    * Update fuse_doc for rosdoc2
    ---------
    Co-authored-by: Shane Loretz <mailto:sloretz@google.com>
  * fuse -> ROS 2 fuse_models: Port fuse_models (#304 <https://github.com/locusrobotics/fuse/issues/304>)
    * Port messages
    * Port fuse_models
    * Fix alloc error and some bugs
    * Wait on result
  * fuse -> ROS 2 fuse_graphs : Port fuse_graphs (#289 <https://github.com/locusrobotics/fuse/issues/289>)
  * fuse -> ROS 2 fuse_variables: Linting (#296 <https://github.com/locusrobotics/fuse/issues/296>)
    * Migrate to .hpp files
    * Create redirection headers
    * Make xmllint and uncrustify happy
    * Wrap most comment lines
    * Satisfy cpplint
  * fuse -> ROS 2 fuse_loss: Linting (#295 <https://github.com/locusrobotics/fuse/issues/295>)
  * fuse -> ROS 2 fuse_loss: Port fuse_loss (#287 <https://github.com/locusrobotics/fuse/issues/287>)
  * fuse -> ROS 2 fuse_core: Linting (#292 <https://github.com/locusrobotics/fuse/issues/292>)
  * fuse -> ROS 2: Clean up macro usage warnings (#280 <https://github.com/locusrobotics/fuse/issues/280>)
  * fuse -> ROS 2 fuse_msgs : Port package and ignore unported packages for now (#277 <https://github.com/locusrobotics/fuse/issues/277>)
    Co-authored-by: Tom Moore <mailto:tmoore@locusrobotics.com>
  * Adding doxygen to all packages (#241 <https://github.com/locusrobotics/fuse/issues/241>)
  * Contributors: Tom Moore, methylDragon

 -- Stephen Williams <swilliams@locusrobotics.com>  Thu, 02 Mar 2023 16:00:00 -0000

ros-iron-fuse-loss (0.4.2-3jammy) jammy; urgency=high

  * Adding roslint dependency to fuse_viz (#231 <https://github.com/locusrobotics/fuse/issues/231>)
    * Adding roslint dependency to fuse_viz
    * Silence CMP0048 warnings
  * Contributors: Tom Moore

 -- Stephen Williams <swilliams@locusrobotics.com>  Mon, 19 Jul 2021 16:00:00 -0000

ros-iron-fuse-loss (0.4.1-3jammy) jammy; urgency=high

  * Changelogs
  * Fix roslint 0.12.0 (#186 <https://github.com/locusrobotics/fuse/issues/186>)
    * Fix roslint 0.12.0 include_what_you_use warnings
    Mostly for:
    * std::move -> #include <utility>
    * std::make_shared and similar -> #include <memory>
    * Remove static string variable not permitted by roslint 0.12.0, using a test fixture where needed.
  * Replace ignition_sensors list param with ignition field (#163 <https://github.com/locusrobotics/fuse/issues/163>)
    * Remove ignition_sensors param and use a per-sensor ignition field
  * Add ComposedLoss (#170 <https://github.com/locusrobotics/fuse/issues/170>)
  * Patch Tukey loss for Ceres < 2.0.0 (#159 <https://github.com/locusrobotics/fuse/issues/159>)
    * Patch Tukey loss for Ceres < 2.0.0
    * Create ceres_macros.h header
  * Plot loss (#143 <https://github.com/locusrobotics/fuse/issues/143>)
    * Add test to plot loss rho, influence and weight
    * Add BUILD_WITH_PLOT_TESTS option (defaults OFF)
  * Remove Pseudo-Huber loss, it duplicates SoftLOne (#152 <https://github.com/locusrobotics/fuse/issues/152>)
    * Remove Pseudo-Huber loss, it duplicates SoftLOne
  * Add new loss functions (#142 <https://github.com/locusrobotics/fuse/issues/142>)
    The following loss functions, not available in Ceres solver are
    provided:
    * Geman-McClure
    * DCS (Dynamic Covariance Scaling)
    * Fair
    * Pseudo-Huber
    * Welsch
  * Support ScaledLoss (#141 <https://github.com/locusrobotics/fuse/issues/141>)
  * Add fuse_loss pkg with plugin-based loss functions (#118 <https://github.com/locusrobotics/fuse/issues/118>)
  * Contributors: Enrique Fernandez Perdomo, Stephen Williams, Tom Moore
  * Fix roslint 0.12.0 (#186 <https://github.com/locusrobotics/fuse/issues/186>)
    * Fix roslint 0.12.0 include_what_you_use warnings
    Mostly for:
    * std::move -> #include <utility>
    * std::make_shared and similar -> #include <memory>
    * Remove static string variable not permitted by roslint 0.12.0, using a test fixture where needed.
  * Replace ignition_sensors list param with ignition field (#163 <https://github.com/locusrobotics/fuse/issues/163>)
    * Remove ignition_sensors param and use a per-sensor ignition field
  * Add ComposedLoss (#170 <https://github.com/locusrobotics/fuse/issues/170>)
  * Patch Tukey loss for Ceres < 2.0.0 (#159 <https://github.com/locusrobotics/fuse/issues/159>)
    * Patch Tukey loss for Ceres < 2.0.0
    * Create ceres_macros.h header
  * Plot loss (#143 <https://github.com/locusrobotics/fuse/issues/143>)
    * Add test to plot loss rho, influence and weight
    * Add BUILD_WITH_PLOT_TESTS option (defaults OFF)
  * Remove Pseudo-Huber loss, it duplicates SoftLOne (#152 <https://github.com/locusrobotics/fuse/issues/152>)
    * Remove Pseudo-Huber loss, it duplicates SoftLOne
  * Add new loss functions (#142 <https://github.com/locusrobotics/fuse/issues/142>)
    The following loss functions, not available in Ceres solver are
    provided:
    * Geman-McClure
    * DCS (Dynamic Covariance Scaling)
    * Fair
    * Pseudo-Huber
    * Welsch
  * Support ScaledLoss (#141 <https://github.com/locusrobotics/fuse/issues/141>)
  * Add fuse_loss pkg with plugin-based loss functions (#118 <https://github.com/locusrobotics/fuse/issues/118>)
  * Contributors: Enrique Fernandez Perdomo, Stephen Williams

 -- Stephen Williams <swilliams@locusrobotics.com>  Mon, 12 Jul 2021 16:00:00 -0000

ros-iron-fuse-loss (0.4.0-3jammy) jammy; urgency=high



 -- Stephen Williams <swilliams@locusrobotics.com>  Thu, 11 Jul 2019 16:00:00 -0000

ros-iron-fuse-loss (0.3.0-3jammy) jammy; urgency=high





=== debian/control ===
Source: ros-iron-fuse-loss
Section: misc
Priority: optional
Maintainer: Stephen Williams <swilliams@locusrobotics.com>
Build-Depends: debhelper (>= 9.0.0), libceres-dev, libqwt-qt5-dev <!nocheck>, qtbase5-dev <!nocheck>, ros-iron-ament-cmake-gtest <!nocheck>, ros-iron-ament-cmake-ros, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-fuse-core, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-fuse-loss
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libceres-dev, ros-iron-fuse-core, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-ros-workspace
Description: The fuse_loss package provides a set of commonly used loss functions, such as the basic ones provided by Ceres.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-fuse-loss//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
